;
	 LIST         P = PIC18F2550, F = INHX32, R = DEC 
     INCLUDE      "P18F2550.INC" 

	cblock 	0x00			;start of general purpose registers
			COUNTER
			COUNTER_H
			DIRECTION
			SHIFT_REG
			FINAL_REG
;
			count			;used in looping routines
			count1			;used in delay routine
			counta			;used in delay routine
			countb			;used in delay routine
			TEMP01
		
	endc
MAX_COUNT       equ     d'2500'-1 	     
	
	;======================================= 
         		ORG	0x00
 		GOTO     	MAIN_ROUTINE
		ORG      	0x08 
INT_SERVE:                              
		MOVF	PORTB,W
		MOVWF	DIRECTION
		BTFSC    	DIRECTION, 2 ;	If not enabled - quit
		BRA	INT_SERVE_END		

       		btfsc   	DIRECTION,1 
        		bra     	DO_DECR 
DO_INCR: 
        		RRNCF   	SHIFT_REG, 1
		MOVFF   	SHIFT_REG, FINAL_REG
;
		movlw   	low MAX_COUNT 
        		cpfseq  	COUNTER+0 
        		bra     	DO_INCR2 
; 
        		movlw   	high MAX_COUNT 
        		cpfseq  	COUNTER+1 
        		bra     	DO_INCR2 
; 
        		clrf    	COUNTER+0 
        		clrf    	COUNTER+1 
		BRA	INT_MARKER
DO_INCR2: 
        		infsnz  	COUNTER+0,f 
        		incf    	COUNTER+1,f 
		BRA	INT_MARKER
;
DO_DECR: 
        		RLNCF   	SHIFT_REG,1
		MOVFF   	SHIFT_REG, FINAL_REG
		movlw   	-1 
        		addwf   	COUNTER+0,f 
        		addwfc  	COUNTER+1,f 
        		btfsc   	STATUS,C 
		BRA	INT_MARKER
; 
        		movlw   	low  MAX_COUNT 
        		movwf   	COUNTER+0 
        		movlw   	high MAX_COUNT 
        		movwf   	COUNTER+1 
;		
INT_MARKER:	
		movlw  	b'11111110' 
        		andwf   	COUNTER+0,w 
        		iorwf   	COUNTER+1,w 
        		BZ	SET_MARKER 
		BCF     	FINAL_REG,4 
		BSF     	FINAL_REG,5
		BRA	INT_DONE
SET_MARKER:	
		BSF     	FINAL_REG,4 
		BCF     	FINAL_REG,5
;
;-------------------------------------------------- 
INT_DONE:		
		MOVFF	FINAL_REG, LATA
;
INT_SERVE_END: 
         		BCF	INTCON, INT0IF
		RETFIE   	FAST          	; Use fast return stack          
;=======================================  

			
		


;--------------------------------------------------
		ORG      0x90
MAIN_ROUTINE:
;		
;
;
Start		clrf	TRISA			 
		movlw 	b'00000111'
   		movwf 	TRISB
		movlw 	b'00001111' 	; SET ALL INPUT AS DIGITAL
   		movwf 	ADCON1
		movlw 	b'10000000'	;set PortC all outputs, bit 7 for input
   		movwf 	TRISC
		movlw 	b'00110011' ;set SHIFT_REG initial data
   		movwf	SHIFT_REG
		movlw 	b'00100011' ;set PortA initial data
		movwf 	LATA
;		
		CALL	SER_INIT
		CLRF	COUNTER
		CLRF	COUNTER_H
		BSF	INTCON, INT0IE
		BSF	INTCON, GIE		;ENABLE INTERRUPTS
		BSF	INTCON, PEIE
;
MAIN_LOOP:
		call	Delay255		;wait so you can see the digits change
send_header	btfss	PIR1, TXIF
		bra	send_header
		MOVLW	d'252'		
		MOVWF	TXREG
		NOP
		;call 	Delay5
send_high		btfss	PIR1, TXIF
		bra	send_high
		MOVFF	COUNTER_H, TXREG
		NOP
		;call	Delay5
send_low		btfss	PIR1, TXIF
		bra	send_low
		MOVFF	COUNTER, TXREG
		goto	MAIN_LOOP
;
;
SER_INIT:
		MOVLW	b'01001000'
		MOVWF	BAUDCON
		MOVLW   d'55'                 	;38400 baud @ 48 Mhz Fosc = 311 (256+55)
     		MOVWF   SPBRG
		MOVLW	d'1'
		MOVWF	SPBRGH
     		MOVLW   b'00100100'           	;brgh = 1
     		MOVWF   TXSTA                 	;enable Async Transmission, set brgh            	
     		MOVLW   b'10010000'
		MOVWF   RCSTA           		;enable Async Reception
       		RETURN

;
Delay255	movlw	0xff			;delay 255 mS
		goto	d0
Delay100	movlw	d'100'			;delay 100mS
		goto	d0
Delay50		movlw	d'50'			;delay 50mS
		goto	d0
Delay20		movlw	d'20'			;delay 20mS
		goto	d0
Delay5		movlw	0x05			;delay 5.000 ms 
d0		movwf	count1
d1		movlw	0xEF			;delay 1mS
		movwf	counta
		movlw	0x2
		movwf	countb
Delay_0	
		decfsz	counta, f
		goto	d2
		decfsz	countb, f
d2		goto	Delay_0
		decfsz	count1	,f
		goto	d1
		retlw	0x00

		END
